﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;
using System.Collections.ObjectModel;
using System.Collections.Generic;

namespace DragAndDrop_TreeView_ListBox
{
	public class CategoryViewModel
	{
		public static IList Generate()
		{
			CategoryViewModel latest = new CategoryViewModel();
			latest.Title = "Latest Additions";
			foreach (ProductViewModel item in ProductViewModel.Generate(4))
			{
				latest.Items.Add(item);
			}
			CategoryViewModel highestRated = new CategoryViewModel();
			highestRated.Title = "Highest Rated";
			foreach (ProductViewModel item in ProductViewModel.Generate(5))
			{
				highestRated.Items.Add(item);
			}
			return new ObservableCollection<object>()
			{
				latest, highestRated
			};
		}

		public CategoryViewModel()
		{
			Items = new ObservableCollection<object>();
		}

		public string Title
		{
			get;
			set;
		}

		public IList Items
		{
			get;
			set;
		}
		}



		public class ProductViewModel
		{
			// Data generation.
			private static Random generator = new Random(1676545846);
			private static string[] adjectives = "Fabulous,Amazing,New,Classic,Modern,Durable,Outstanding,Excellent,Premium".Split(',');
			private static string[] owner = "Alaska,Jonhn,Ray,Ruby,Stone,Lilly,Scott,Barney,Dorian,Neo,Sarah".Split(',');
			private static string[] objects = "Pen,Manual,Bicycle,Umbrella,Mouse,Vase,Keyboard".Split(',');
			private static decimal[] prices = { 12.99M, 13.15M, 24.99M, 33.99M, 9.99M, 15.99M, 16.99M, 12.50M };

			public static IEnumerable<ProductViewModel> Generate(int count)
			{
				for (int i = 0; i < count; i++)
				{
					string product = objects[generator.Next(objects.Length)];
					ProductViewModel result = new ProductViewModel();
					result.Name = String.Format("{0}'s {1} {2}",
												owner[generator.Next(owner.Length)],
												adjectives[generator.Next(adjectives.Length)],
												product);
					result.UnitPrice = prices[generator.Next(prices.Length)];
					result.Description = String.Format("Exquisite handcrafted {0}.", product.ToLower());
					yield return result;
				}
			}

			public string Name
			{
				get;
				set;
			}

			public string Description
			{
				get;
				set;
			}

			public decimal UnitPrice
			{
				get;
				set;
			}
		}  
	
}
